Unit Crt;

{$I-,S-}

InterFace

{$IFNDEF WINDOWS}
Type
	OutProcType = Procedure(Size: Word; Str: PChar);
	CharFuncType = Function: Char;
  BoolFuncType = Function: Boolean;

	GotoXYProcType = Procedure(X,Y: Integer);
	WindowProcType = Procedure(X1,Y1,X2,Y2: Integer);
	ByteFuncType = Function: Integer;
	OneProcType = Procedure;

	CrtSaveBuf = Record
		TextAttr,NormAttr,BreakFlag,DummyChar: Byte;
    LocalEcho: Boolean;
		CursX,CursY:Integer;
    CurCrtSize:Word;
    WriteStrProcAddr: OutProcType;
    ReadKeyAddr: CharFuncType;
    KeyPressedAddr: BoolFuncType;

		GotoXYProcAddr: GotoXYProcType;
    WhereXFuncAddr: ByteFuncType;
		WhereYFuncAddr: ByteFuncType;
    WindowProcAddr: WindowProcType;
    ClrScrProcAddr: OneProcType;
  End;

Const
{ CRT modes }
  BW40          = 0;            { 40x25 B/W on Color Adapter }
  CO40          = 1;            { 40x25 Color on Color Adapter }
  BW80          = 2;            { 80x25 B/W on Color Adapter }
	CO80          = 3;            { 80x25 Color on Color Adapter }
  Mono          = 7;            { 80x25 on Monochrome Adapter }
  Font8x8       = 256;          { Add-in for ROM font }

{ Mode constants for 3.0 compatibility }
  C40           = CO40;
  C80           = CO80;

{ Foreground and background color constants }
  Black         = 0;
  Blue          = 1;
  Green         = 2;
	Cyan          = 3;
  Red           = 4;
  Magenta       = 5;
  Brown         = 6;
  LightGray     = 7;

{ Foreground color constants }
  DarkGray      = 8;
  LightBlue     = 9;
  LightGreen    = 10;
  LightCyan     = 11;
	LightRed      = 12;
  LightMagenta  = 13;
	Yellow        = 14;
	White         = 15;

{ Add-in for blinking }
	Blink         = 128;

Var
{ Interface variables }
	CheckBreak: Boolean;    { Enable Ctrl-Break }
	CheckEOF: Boolean;      { Enable Ctrl-Z }
	DirectVideo: Boolean;   { Enable direct video addressing }
	CheckSnow: Boolean;     { Enable snow filtering }
	LastMode: Word;         { Current text mode }
	WindMin: Word;          { Window upper left coordinates }
	WindMax: Word;          { Window lower right coordinates }
	CRTLocal: CrtSaveBuf;
	TextAttr: Byte Absolute CrtLocal;
  {$IFNDEF NOSTDIO}
	OldInput, OldOutPut: Text;
  {$ENDIF}

{ Interface procedures }
function KeyPressed: Boolean;
function ReadKey: Char;
procedure TextMode(Mode: Integer);
procedure Window(X1,Y1,X2,Y2: Integer);
procedure GotoXY(X,Y: Integer);
function WhereX: Integer;
function WhereY: Integer;
procedure ClrScr;
procedure ClrEOL;
procedure InsLine;
procedure DelLine;
procedure TextColor(Color: Byte);
procedure TextBackground(Color: Byte);
procedure LowVideo;
procedure HighVideo;
procedure NormVideo;
{$IFNDEF NOSTDIO}
procedure AssignCrt(var F: Text);
{$ENDIF}
procedure Delay(MS: Word);
procedure Sound(Hz: Word);
procedure NoSound;

Function FalseFunc: Boolean;
Function TrueFunc: Boolean;

Function CrtOldReadKey:Char;
Function CrtOldKeyPressed:Boolean;

Procedure YesSound;

{$IFNDEF NOSTDIO}
Procedure CrtOldWrite(Size: Word; Str: PChar);

Procedure CrtOldGotoXY(X,Y: Integer);
Function CrtOldWhereX:Integer;
Function CrtOldWhereY:Integer;

Procedure CrtOldWindow(X1,Y1,X2,Y2:Integer);
Procedure CrtOldClrScr;

Procedure ClrSOL;
Procedure CrtSetup;
Procedure SwapInOut;
{$ENDIF}

Procedure CrtSave(Var Buf: CrtSaveBuf);
Procedure CrtRestore(Var Buf: CrtSaveBuf);

Procedure FastWrite(Var VideoBuf; x,y,Attr:Byte; s: PChar); {Nollasta alkavat}

{$IFNDEF NOSTDIO}
Procedure ReInit;

Function cgets(str: PChar): PChar;

Const
  CGAll  = [#0..#255];
  CGNums = ['0'..'9','-','.',#8,#13];
  CGChars= ['A'..'Z','a'..'z',#8,#13];
  CGUmla = [''..'',#8,#13];

  CGMinLen: Byte = 1;
	CGAllowed: Set Of Char = CGAll;
	CGWaiting: Procedure(Blank: Char) = Nil;
  ClearCGets: Boolean = True;
{$ENDIF}

Const
  VideoBufferSave: PChar = Nil;

(** End of userdefined symbols **)

{$ENDIF}

Implementation

{$IFNDEF Windows}

{$IFDEF DPMI}
 {$L CRT_CRT.OBP}
{$ELSE}
 {$L CRT_CRT.OBJ}
{$ENDIF}

{$L CRT_2.OBJ}
{$L CRT_SR.OBJ}
{$L CRT_USUA.OBJ}
{$L CRT_SNDS.OBJ}
{$L CRT_COLR.OBJ}

Type
  TextRec = Array[Byte]Of Byte;
Var
  DelayCnt: LongInt;
  ScanCode: Byte; {For crt_crt.asm}

procedure Initialize; near; external;
function KeyPressed; external;
function ReadKey; external;
procedure TextMode; external;
procedure Delay; external;
procedure Sound; external;
procedure NoSound; external;

Function FalseFunc; Assembler; Asm xor ax, ax End;
Function TrueFunc;  Assembler; Asm mov al, 1 End;

Procedure CrtSave; external;
Procedure CrtRestore; external;

Procedure CrtSetup; External;
Procedure YesSound; External;

Function CrtOldReadKey:Char; External;
Function CrtOldKeyPressed:Boolean; External;

procedure InsLine; external;
procedure DelLine; external;
procedure TextColor; external;
procedure TextBackground; external;
procedure LowVideo; external;
procedure HighVideo; external;
procedure NormVideo; external;

Procedure Window; external;
Procedure GotoXY; external;
Function WhereX; external;
Function WhereY; external;
Procedure ClrScr; external;
Procedure ClrEOL; external;

{$IFNDEF NOSTDIO}
procedure AssignCrt; external;

Procedure CrtOldWrite(Size: Word; Str: PChar); External;

Procedure CrtOldGotoXY(X,Y: Integer); External;
Function CrtOldWhereX:Integer; External;
Function CrtOldWhereY:Integer; External;

Procedure CrtOldWindow(X1,Y1,X2,Y2: Integer); External;
Procedure CrtOldClrScr; External;

Procedure ClrSOL; External;

Procedure SwapInOut;
Var Temp: Text;
Begin
  TextRec(Temp) := TextRec(InPut);
  TextRec(InPut):= TextRec(OldInPut);
  TextRec(OldInPut):= TextRec(Temp);

  TextRec(Temp) := TextRec(OutPut);
  TextRec(OutPut):= TextRec(OldOutPut);
  TextRec(OldOutPut):= TextRec(Temp);
End;

Procedure ReInit; Assembler;
Asm call Initialize End;

{$ENDIF}
Procedure FastWrite(Var VideoBuf; x,y,Attr:Byte; s: PChar); Assembler;
Asm
        mov al, y
        mov ah, 80
        mul ah
        mov bl, x
        xor bh, bh
        add bx, ax
        add bx, bx

        cld
				push ds
         les di, VideoBuf
         lds si, s
         mov ah, Attr
@@1:     lodsb
				 or al, al
         jz @@2
         mov es:[di+bx], ax
         inc bx
         inc bx
         jmp @@1
@@2:    pop ds
End;

{$IFNDEF NOSTDIO}
 {$I CGets.INC}
{$ENDIF}

(** End of userdefined symbols **)
Begin
  Asm
    mov al, 34h; out 43h, al
    xor al, al
    out 40h, al
    out 40h, al
  End;

	With CRTLocal Do
  Begin
    ReadKeyAddr      := CrtOldReadKey;
		KeyPressedAddr   := CrtOldKeyPressed;
    {$IFNDEF NOSTDIO}
    WriteStrProcAddr := CrtOldWrite;

		GotoXYProcAddr   := CrtOldGotoXY;
		WhereXFuncAddr   := CrtOldWhereX;
		WhereYFuncAddr   := CrtOldWhereY;
		WindowProcAddr   := CrtOldWindow;
    ClrScrProcAddr   := CrtOldClrScr;

    LocalEcho := True
    {$ENDIF}
	End;

	Initialize;
  {$IFNDEF NOSTDIO}

	TextRec(OldInPut) := TextRec(InPut);
	TextRec(OldOutPut):= TextRec(OutPut);

	AssignCrt(Input); Reset(Input);
	AssignCrt(Output); ReWrite(Output);
  {$ENDIF}

{$ENDIF}
End.
