; *******************************************************
; *     CRT Interface Unit                              *
; *******************************************************

        TITLE   CRT

        INCLUDE SE.ASM

.8086

; Coordinate record
X       EQU     (BYTE PTR 0)
Y       EQU     (BYTE PTR 1)


DATA    SEGMENT WORD PUBLIC

; Externals
        extrn   ModeX:Byte,GraphMode:byte                     ; From SYSTEM
        EXTRN   CheckBreak:BYTE,CheckEOF:BYTE,DirectVideo:BYTE
        EXTRN   CheckSnow:BYTE,LastMode:WORD
        EXTRN   WindMin:WORD,WindMax:WORD,Seg0040:WORD
        EXTRN   SegB000:WORD,SegB800:WORD

        extrn CRTLocal : byte ; Table of following:

include crt_save.inc

DelayCnt dw ?

DATA    ENDS

CODE    SEGMENT BYTE PUBLIC

        ASSUME  CS:CODE,DS:DATA

; Externals
        EXTRN   HaltTurbo:FAR
        extrn GetCursor:near,SetCursor:near

; Publics
        PUBLIC  Window,GotoXY,WhereX,WhereY
        PUBLIC  ClrEOL,ClrSOL,InsLine,DelLine

; Clear to end-of-line ; .ASM <- that is for BP...
ClrEol: CALL    GetCursor
        MOV     AX,600h
        MOV     BH,TextAttr
        MOV     CX,DX
        MOV     DL,WindMax.X
        CALL    Video
        RETF

; Clear to start-of-line
ClrSol: CALL    GetCursor
        MOV     AX,600h
        MOV     BH,TextAttr
        MOV     CX,DX
        mov dh,0
        MOV     DL,WindMax.X
        CALL    Video
        RETF

; Insert line
InsLine:MOV     AX,701h
        JMP     SHORT InsDelLine

; Delete line
DelLine:MOV     AX,601h

InsDelLine:
        PUSH    AX
         CALL    GetCursor
        POP     AX
        MOV     BH,TextAttr
        MOV     CL,WindMin.X
        MOV     CH,DH
        MOV     DX,WindMax
        CMP     CH,DH
        JNE     @@1
        XOR     AL,AL
@@1:    CALL    Video
        RETF

; Save registers and call BIOS video routine
Video:  PUSH    SI
         PUSH    DI
          PUSH    BP
           PUSH    ES
            INT     10H
           POP     ES
          POP     BP
         POP     DI
        POP     SI
        RETn

; Define output window
Window: jmp dword ptr WindowProcAddr
; Position cursor
GotoXY: jmp dword ptr GotoXYProcAddr
; Return cursor X coordinate
WhereX: jmp dword ptr WhereXFuncAddr
; Return cursor Y coordinate
WhereY: jmp dword ptr WhereYFuncAddr

CODE    ENDS

        END
